//
//  editTypeBottomView.m
//  双子星云手机
//
//  Created by xd h on 2024/5/14.
//

#import "editTypeBottomView.h"

@interface editTypeBottomView ()
@property(nonatomic,strong) UIButton*leftButton;
@property(nonatomic,strong) UIButton*rightButton;
@property(nonatomic,strong) UIButton*midButton;
@end

@implementation editTypeBottomView

- (id)initWithFrame:(CGRect)frame{
    self = [super initWithFrame:frame];
    self.backgroundColor = [UIColor whiteColor];
    [self drawAnyView];
    return self;
}

- (void)drawAnyView{
    
    CGFloat curButFullWidth = SCREEN_W/3.0;
    
    _leftButton = [[UIButton alloc] init];
    [_leftButton addTarget:self action:@selector(didClickButFun:) forControlEvents:UIControlEventTouchUpInside];
    _leftButton.tag = 1;
    [self addSubview:_leftButton];
    
    [_leftButton mas_makeConstraints:^(MASConstraintMaker *make) {
        make.width.mas_equalTo(curButFullWidth);
        make.left.mas_equalTo(0);
        make.height.mas_equalTo(60);
        make.top.mas_equalTo(0);
    }];
    
    UIImageView *leftImageV = [[UIImageView alloc] init];
    leftImageV.image = [UIImage imageNamed:@"edit_download_icon"];
    [_leftButton addSubview:leftImageV];
    
    [leftImageV mas_makeConstraints:^(MASConstraintMaker *make) {
        make.width.mas_equalTo(25);
        make.height.mas_equalTo(25);
        make.centerX.equalTo(_leftButton.mas_centerX);
        make.centerY.equalTo(_leftButton.mas_centerY).offset(-10);
    }];
    
    UILabel *leftLabel = [[UILabel alloc] init];
    leftLabel.textColor = [UIColor hwColor:@"#0A132B"];
    leftLabel.textAlignment = NSTextAlignmentCenter;
    leftLabel.font = [UIFont systemFontOfSize:12.0];
    leftLabel.text = NSLocalizedString(@"my_set_no_File_download",nil);
    [_leftButton addSubview:leftLabel];
    
    [leftLabel mas_makeConstraints:^(MASConstraintMaker *make) {
        make.width.mas_equalTo(curButFullWidth);
        make.height.mas_equalTo(25);
        make.centerX.equalTo(_leftButton.mas_centerX);
        make.centerY.equalTo(_leftButton.mas_centerY).offset(10);
    }];
    
    _midButton = [[UIButton alloc] init];
    [_midButton addTarget:self action:@selector(didClickButFun:) forControlEvents:UIControlEventTouchUpInside];
    _midButton.tag = 2;
    [self addSubview:_midButton];
    
    [_midButton mas_makeConstraints:^(MASConstraintMaker *make) {
        make.width.mas_equalTo(curButFullWidth);
        make.left.mas_equalTo(curButFullWidth);
        make.height.mas_equalTo(60);
        make.top.mas_equalTo(0);
    }];
    
    UIImageView *midImageV = [[UIImageView alloc] init];
    midImageV.image = [UIImage imageNamed:@"edit_share_icon"];
    [_midButton addSubview:midImageV];
    
    [midImageV mas_makeConstraints:^(MASConstraintMaker *make) {
        make.width.mas_equalTo(25);
        make.height.mas_equalTo(25);
        make.centerX.equalTo(_midButton.mas_centerX);
        make.centerY.equalTo(_midButton.mas_centerY).offset(-10);
    }];
    
    UILabel *midLabel = [[UILabel alloc] init];
    midLabel.textColor = [UIColor hwColor:@"#0A132B"];
    midLabel.textAlignment = NSTextAlignmentCenter;
    midLabel.font = [UIFont systemFontOfSize:12.0];
    midLabel.text = NSLocalizedString(@"common_edit_share",nil);
    [_midButton addSubview:midLabel];
    
    [midLabel mas_makeConstraints:^(MASConstraintMaker *make) {
        make.width.mas_equalTo(curButFullWidth);
        make.height.mas_equalTo(25);
        make.centerX.equalTo(_midButton.mas_centerX);
        make.centerY.equalTo(_midButton.mas_centerY).offset(10);
    }];
    
    
    _rightButton = [[UIButton alloc] init];
    [_rightButton addTarget:self action:@selector(didClickButFun:) forControlEvents:UIControlEventTouchUpInside];
    _rightButton.tag = 3;
    [self addSubview:_rightButton];
    
    [_rightButton mas_makeConstraints:^(MASConstraintMaker *make) {
        make.width.mas_equalTo(curButFullWidth);
        make.right.mas_equalTo(0);
        make.height.mas_equalTo(60);
        make.top.mas_equalTo(0);
    }];
    
    UIImageView *rightImageV = [[UIImageView alloc] init];
    rightImageV.image = [UIImage imageNamed:@"edit_del_icon"];
    [_rightButton addSubview:rightImageV];
    
    [rightImageV mas_makeConstraints:^(MASConstraintMaker *make) {
        make.width.mas_equalTo(25);
        make.height.mas_equalTo(25);
        make.centerX.equalTo(_rightButton.mas_centerX);
        make.centerY.equalTo(_rightButton.mas_centerY).offset(-10);
    }];
    
    UILabel *rightLabel = [[UILabel alloc] init];
    rightLabel.textColor = [UIColor hwColor:@"#0A132B"];
    rightLabel.textAlignment = NSTextAlignmentCenter;
    rightLabel.font = [UIFont systemFontOfSize:12.0];
    rightLabel.text = NSLocalizedString(@"File_upload_Record_delete",nil);
    [_rightButton addSubview:rightLabel];
    
    [rightLabel mas_makeConstraints:^(MASConstraintMaker *make) {
        make.width.mas_equalTo(curButFullWidth);
        make.height.mas_equalTo(25);
        make.centerX.equalTo(_rightButton.mas_centerX);
        make.centerY.equalTo(_rightButton.mas_centerY).offset(10);
    }];
//    
}

- (void)didClickButFun:(UIButton*)but
{
    NSInteger tag = but.tag;
    
    if(_didClickButtonFun){
        _didClickButtonFun(tag);
    }
}


- (void)setButtonStateFunBy:(BOOL)canClick
{
    CGFloat alpha = canClick ? 1.0 : 0.5;
    _leftButton.enabled = canClick;
    _rightButton.enabled = canClick;
    _midButton.enabled = canClick;
    
    _leftButton.alpha = alpha;
    _rightButton.alpha = alpha;
    _midButton.alpha = alpha;
}

- (void)setCanShaewFunBy:(BOOL)canShare
{
    //test code
    //canShare = NO;
   
    _midButton.hidden = !canShare;
    
    if(canShare){
        CGFloat curButFullWidth = SCREEN_W/3.0;
        [_leftButton mas_remakeConstraints:^(MASConstraintMaker *make) {
            make.width.mas_equalTo(curButFullWidth);
            make.left.mas_equalTo(0);
            make.height.mas_equalTo(60);
            make.top.mas_equalTo(0);
        }];
        
        [_midButton mas_remakeConstraints:^(MASConstraintMaker *make) {
            make.width.mas_equalTo(curButFullWidth);
            make.left.mas_equalTo(curButFullWidth);
            make.height.mas_equalTo(60);
            make.top.mas_equalTo(0);
        }];
        
        [_rightButton mas_remakeConstraints:^(MASConstraintMaker *make) {
            make.width.mas_equalTo(curButFullWidth);
            make.right.mas_equalTo(0);
            make.height.mas_equalTo(60);
            make.top.mas_equalTo(0);
        }];
    }
    else{
        CGFloat curButFullWidth = SCREEN_W/2.0;
        [_leftButton mas_remakeConstraints:^(MASConstraintMaker *make) {
            make.width.mas_equalTo(curButFullWidth);
            make.left.mas_equalTo(0);
            make.height.mas_equalTo(60);
            make.top.mas_equalTo(0);
        }];
        
//        [_midButton mas_remakeConstraints:^(MASConstraintMaker *make) {
//            make.width.mas_equalTo(curButFullWidth);
//            make.left.mas_equalTo(curButFullWidth);
//            make.height.mas_equalTo(60);
//            make.top.mas_equalTo(0);
//        }];
        
        [_rightButton mas_remakeConstraints:^(MASConstraintMaker *make) {
            make.width.mas_equalTo(curButFullWidth);
            make.right.mas_equalTo(0);
            make.height.mas_equalTo(60);
            make.top.mas_equalTo(0);
        }];
    }
}
@end
