//
//  editTypeHeadView.m
//  双子星云手机
//
//  Created by xd h on 2024/5/14.
//

#import "editTypeHeadView.h"

@interface editTypeHeadView ()
@property(nonatomic,strong) UIButton*leftButton;
@property(nonatomic,strong) UIButton*rightButton;
@property(nonatomic,strong) UILabel*selectNumLabel;
@end

@implementation editTypeHeadView

- (id)initWithFrame:(CGRect)frame{
    self = [super initWithFrame:frame];
    self.backgroundColor = [UIColor whiteColor];
    [self drawAnyView];
    return self;
}

- (void)drawAnyView{
    
    _leftButton = [[UIButton alloc] init];
    [_leftButton setTitleColor:[UIColor hwColor:@"#01B7EA" alpha:1.0] forState:UIControlStateNormal];
    _leftButton.titleLabel.font = [UIFont systemFontOfSize:18.0];
    _leftButton.contentHorizontalAlignment = UIControlContentHorizontalAlignmentLeft;
    [_leftButton addTarget:self action:@selector(didClickButFun:) forControlEvents:UIControlEventTouchUpInside];
    _leftButton.tag = 1;
    [_leftButton setTitle:NSLocalizedString(@"other_cancel",nil) forState:UIControlStateNormal];
    [self addSubview:_leftButton];
    
    [_leftButton mas_makeConstraints:^(MASConstraintMaker *make) {
        make.width.mas_equalTo(80);
        make.left.mas_equalTo(15);
        make.height.mas_equalTo(30);
        make.bottom.mas_equalTo(-20);
    }];
    
    _rightButton = [[UIButton alloc] init];
    [_rightButton setImage:[UIImage imageNamed:@"edit_select_all_h"] forState:UIControlStateSelected];
    [_rightButton setImage:[UIImage imageNamed:@"edit_select_all_n"] forState:UIControlStateNormal];
    [_rightButton addTarget:self action:@selector(didClickButFun:) forControlEvents:UIControlEventTouchUpInside];
    _rightButton.tag = 2;
    [self addSubview:_rightButton];
    
    [_rightButton mas_makeConstraints:^(MASConstraintMaker *make) {
        make.width.mas_equalTo(80);
        make.right.mas_equalTo(0);
        make.height.mas_equalTo(30);
        make.bottom.equalTo(_leftButton.mas_bottom);
    }];
    
    _selectNumLabel = [[UILabel alloc] init];
    _selectNumLabel.textAlignment = NSTextAlignmentCenter;
    _selectNumLabel.textColor = [UIColor hwColor:@"#0A132B"];
    _selectNumLabel.font = [UIFont systemFontOfSize:18.0];
    [self addSubview:_selectNumLabel];
    [self setTitleLabetextByNumbers:0];
    
    [_selectNumLabel mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(_leftButton.mas_right).offset(5);
        make.right.equalTo(_rightButton.mas_left).offset(-5);
        make.height.mas_equalTo(30);
        make.bottom.equalTo(_leftButton.mas_bottom);
    }];
}

- (void)setTitleLabetextByNumbers:(NSInteger)didSelectNumbers
{
    //
    _selectNumLabel.text = [[NSString alloc] initWithFormat:@"%@(%ld)",NSLocalizedString(@"common_edit_didSelect",nil),didSelectNumbers];
}


- (void)didClickButFun:(UIButton*)but
{
    NSInteger tag = but.tag;
    
    if(_didClickButtonFun && tag == 1){
        _didClickButtonFun(tag);
    }
    else if(tag ==2){
        but.selected = !but.selected;
        if(_didClickSelectAllFun){
            _didClickSelectAllFun(but);
        }
        
    }
}

@end
